//-----------------------------------------------------------------------------
// vflt.h : LPF
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#pragma once

#include "sysdep.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ARRAYSIZE
#define ARRAYSIZE(a) (sizeof(a)/sizeof(a[0]))
#endif

#ifdef FILTER_FLAG_ACTIVE
typedef PIXEL_YC pix;
#else
#ifndef pix
typedef struct _pix { int16_t a,b,c; } pix;
#endif
#endif

// MT͏cɕ邱Ƃz
typedef void (*VLPF)(pix * restrict, const pix * restrict, int, int, int);

#define COUNT16(a) ((((a) + 0xfU) & ~0xfU) >> 4)
#define COUNT8(a)  ((((a) + 0x7U) & ~0x7U) >> 3)

#define N_TAPS 7
extern const VLPF vflt_16[];
extern const VLPF vflt_mmx[];
extern const VLPF vflt_sse2[];
extern const VLPF vflt_sse2u[];

#ifdef __cplusplus
}
#endif

